//importing geoAlberUsa, topojson
import {select,json,geoPath,geoAlbersUsa,scaleOrdinal,
  schemeCategory10} from 'd3';
import { feature } from 'topojson';


//Array of ten categorical colors which is returned as RGB hexadecimal strings. 
const colorScale = scaleOrdinal(schemeCategory10);
const svg = select('svg');
//For projection, use the geoAlberUsa function
const projection = geoAlbersUsa();
const pathGenerator = geoPath().projection(projection);
//reading the data from json file
json(
  'https://cdn.jsdelivr.net/npm/us-atlas@3/states-10m.json'
).then((data) => {
  const states = feature(data, data.objects.states);
  console.log(states);
  console.log(data);
  
  //using json data to create a map projection
  svg
    .selectAll('path')
    .data(states.features)
    .enter()
    .append('path')
    .attr('class', 'states')
  	.attr('fill', (d) => { return(colorScale(d.properties.name))})
    .attr('d', (d) => pathGenerator(d))
    .append('title')
    .text(d=>d.properties.name);
  //Rendering text with state names in the middle of state
  svg
  .selectAll('text')
  .data(states.features)
  .enter()
  .append('text')
  .text((d) => d.properties.name)
  .attr('x', d=>  pathGenerator.centroid(d)[0]   )
  .attr('y',d=>pathGenerator.centroid(d)[1])
  .attr("text-anchor", "middle")
  .attr("font-size", "15px");
});